#version 330 core

layout(points) in;
layout(points) out;
layout(max_vertices = 30) out;

uniform sampler1D sampler;
uniform vec2 random;

in float life[];
in float type[];
in float vel[];
in vec4 position[];
in vec2 dir[];

out float tf_life;
out float tf_type;
out float tf_vel;
out vec4 tf_position;
out vec2 tf_dir;


//uniform 
float deltaTime=0.1;
float gravity=-0.2;
uniform float time;

void main (void) {
	bool newVertex = false;
	tf_life = life[0];
	tf_type = type[0];
	if (tf_type > 0) {
		tf_life -= time;
		if (tf_life < 0) {
			newVertex = true;
			tf_life = tf_type;
		}
	}
	tf_vel = vel[0];
	tf_position = position[0];
	tf_position.y -= 2 * time * tf_vel;
	tf_dir = dir[0];
	tf_position.x += tf_dir.x * time * tf_vel;
	tf_position.z += tf_dir.y * time * tf_vel;
	if (tf_position.y < -1) {
		if (tf_type > 0) {
			tf_position.y = 200.f;
			EmitVertex();
			EndPrimitive();
		}
	}  else {
		EmitVertex();
		EndPrimitive();
	}
	if (newVertex) {
		vec3 rand = texture(sampler, random.x).xyz;
		tf_life = 0.f;
		tf_type = 0.f;
		tf_vel = random.x /20 + 0.8;
		tf_position.x = tf_position.x - random.x * 10 + 5;
		tf_position.y = 150.f;
		tf_position.z = tf_position.z + random.y * 10 - 5;
		tf_dir.x = random.x/20;
		tf_dir.y = random.y/20;
		EmitVertex();
		EndPrimitive();
	}
}

/*
void update(void)
{
	tf_colour = colour[0];
	tf_colour.x -= 0.75;		// TODO: make this framerate independent

	tf_position = position[0];
	tf_position.xyz += deltaTime*normal[0];
	//tf_position.y -= 0.1;

	tf_normal = normal[0];
	tf_normal.y += deltaTime*gravity;
}

void main(void)
{
/*
	tf_normal = normal[0];
	tf_position = position[0];
	tf_colour = colour[0];
			

	if(tf_colour.x > 0.0)
	{
	EmitVertex();
	EndPrimitive();
	}
	*/
/*
	
	update();

	if(tf_colour.x <= 0.0) // no more life left
	{
		if(tf_colour.y == 1.0) //launcher particle
		{			

			//re-emit launcher particle into sim-stream
			tf_normal = normal[0];
			tf_position = position[0];
			tf_colour = colour[0];
			tf_colour.x = 100.0;

			EmitVertex();
			EndPrimitive();

			// emit new particle into stream
			tf_normal = vec3(0.0, 1.0, 0.0);
			tf_position = position[0];
			tf_colour = colour[0];
			tf_colour.x = 100.0;
			tf_colour.y = 0.0;
			EmitVertex();
			EndPrimitive();

			/*
			tf_normal = vec3(0.0, 1.0, 0.0);
			tf_position = position[0];
			tf_colour = colour[0];
			tf_colour.x = 100.0;
			tf_colour.y = 0.0;
			EmitVertex();
			EndPrimitive();
			*/
	/*	}
		else if(tf_colour.y == 0.0) //particle 1
		{
			// emit new particle into stream
			tf_normal = vec3(-1.0, 2.0, 0.0);
			tf_position = position[0];
			tf_colour = colour[0];
			tf_colour.x = 50.0;
			tf_colour.y = 2.0;
			EmitVertex();
			EndPrimitive();

			tf_normal = vec3(-1.0, 2.0, -1.0);
			tf_position = position[0];
			tf_colour = colour[0];
			tf_colour.x = 50.0;
			tf_colour.y = 2.0;
			EmitVertex();
			EndPrimitive();

			tf_normal = vec3(1.0, 2.0, 0.0);
			tf_position = position[0];
			tf_colour = colour[0];
			tf_colour.x = 50.0;
			tf_colour.y = 2.0;
			EmitVertex();
			EndPrimitive();

			tf_normal = vec3(1.0, 2.0, 1.0);
			tf_position = position[0];
			tf_colour = colour[0];
			tf_colour.x = 50.0;
			tf_colour.y = 2.0;
			EmitVertex();
			EndPrimitive();
		}

	}
	else
	{
		if(tf_colour.y == 1.0) //launcher particle
		{
			tf_normal = normal[0];
			tf_position = position[0]+vec4(0.01);
			EmitVertex();
			EndPrimitive();
		}
		else
		{
			// emit updated particle into stream
			EmitVertex();
			EndPrimitive();

		}
	}
	

}*/
