#version 330

uniform mat4 proj_mat;
uniform mat4 view_mat;
uniform mat4 model_mat;
uniform mat4 normal_mat;

in vec4 in_position;
in vec3 in_normal;
in vec2 in_texture;

out vec2 texCoord;
out vec3 out_normal;

void main()
{
	vec4 newNormal = vec4(in_normal, 1);
	newNormal = normal_mat * newNormal;
	out_normal = vec3(newNormal);
	texCoord = vec2(in_texture);
	gl_Position = proj_mat * view_mat * model_mat * in_position;
}